%% Inteligentni sistemi - Cikel 3: Linearna regresija

%  Navodila - linearna regesija v ve dimenzijah
%  ------------
% 
%  Ta skripta vsebuje kodo, ki vam bo v pomo pri opravljanju vaje. 
%  Da boste uspeno opravili vajo boste morali dopolniti naslednje 
%  funkcije: 
%
%     plotData.m
%     gradientDescent.m
%     computeCost.m
%     gradientDescentMulti.m
%     computeCostMulti.m
%     featureNormalize.m
%     normalEqn.m
%
%  V datotekah, ki niso omenjene na zgornjem seznamu, ni potrebno 
%  spreminjati kode.
%
%  Za ta del vaje boste spremenili nekatere dele te kode za 
%  razline eksperimente (npr. spreminjanje unega parametra).
%

%% Inicializacija

%% ================ Normalizacija znailk ================

%% pobrii pomnilnik in zapri slike
clear ; close all; clc

fprintf('Loading data ...\n');

%% Naloi podatke
data = load('ex3data2.txt');
X = data(:, 1:2);
y = data(:, 3);
m = length(y);

% Izrii nekaj pdoatkovnih tok
fprintf('Prvih 10 primerov iz zbirke podatkov: \n');
fprintf(' x = [%.0f %.0f], y = %.0f \n', [X(1:10,:) y(1:10,:)]');

fprintf('Program je prekinjen. Pritisni ENTER za nadaljevanje.\n');
pause;

% Skaliranje znailk in nastavitev nielne povprene vrednosti
fprintf('Normalizacija znailk ...\n');

[X mu sigma] = featureNormalize(X);

% Dodaj stolpec enic na zaetek matrike X
X = [ones(m, 1) X];


%% ================ Gradientni spust ================

% ====================== VAA KODA ======================
% Instructions: Ta zaetna koda poene algoritem gradientnega spusta 
%               z doloeno stopnjo uenja (alpha).
%
%               Vaa naloga je, da najprej preverite, da so funkcije  
%               computeCost in gradientDescent pripravljene, da lahko  
%               delujejo v tej kodi in da podpirajo vedimenzionalnost.
%
%               Potem poenite algoritem gradientnega spusta pri 
%               razlinih vrednostih alpha in opazujte, pri kateri 
%               dobite najbolji rezultat.
%
%               Nazadnje dopolnite kodo na koncu in ocenite/napovejte
%               ceno 183 m2 velike hie s 3 spalnicami.
%
% Opomba: Z uporabo 'hold on' ukaza lahko v istem oknu izriete ve
%       grafov.
%         Pri ocenjevanju uporabite enako normalizacijo!
%

fprintf('Izvajanje gradientnega spusta ...\n');

% Izberite vrednost alpha
alpha = 0.01;
num_iters = 400;

% Inicializacija parametrov theta ter izvedba gradientnega spusta
theta = zeros(3, 1);
[theta, J_history] = gradientDescentMulti(X, y, theta, alpha, num_iters);

% Izris poteka konvergence
figure;
plot(1:numel(J_history), J_history, '-b', 'LineWidth', 2);
xlabel('tevilo iteracij');
ylabel('Stroek J');

% Prikai rezultat gradientnega spusta
fprintf('Theta izraunan z gradientnim spustom: \n');
fprintf(' %f \n', theta);
fprintf('\n');

% Ocenite vrednost 183 m2 velike hie s 3 sobami
% ====================== VAA KODA ======================
% Prvi stolpec v X so same enice, zato tega stolpca ni potrebno
% normalizirati. 

price = 0; % Ta del spremenite


% ============================================================

fprintf(['Ocenjena vrednost 183m2 velike hie s 3 sobami' ...
         '(z uporabo gradientnega spusta):\n $%f\n'], price);

fprintf('Program je prekinjen. Pritisni ENTER za nadaljevanje.\n');
pause;

%% ================ Normalne enabe ================

fprintf('Reevanje z normalno obliko enab ...\n');

% ====================== VAA KODA ======================
% Navodila: Sledea koda izrauna zaprto obliko reitve za linearno 
%           regresijo z uporabo normalne oblike enab. Za ta namen
%           dopolnite kodo v datoteki normalEqn.m
%               
%           Potem dopolnite e kodo na tem mestu za oceno vrednosti 
%           183m2 velike hie s tremi sobami.
%

%% Naloi podatke
data = csvread('ex1data2.txt');
X = data(:, 1:2);
y = data(:, 3);
m = length(y);

% Dodaj stolpec enic na zaetek X
X = [ones(m, 1) X];

% Izraunaj parametre z uporabo normalne enabe
theta = normalEqn(X, y);

% Prikai rezultat normalne enabe
fprintf('Theta izraunan z uporabo normalne oblike enabe: \n');
fprintf(' %f \n', theta);
fprintf('\n');


% Ocena vrednosti hie (vhodna parametra sta velikost v m2 in t. sob)
% ====================== VAA KODA ======================
price = 0; % Spremenite ta del


% ============================================================

fprintf(['Ocenjena vrednost 183m2 velike hie s 3 sobami ' ...
         '(z uporabo normalne enabe):\n $%f\n'], price);

